#include <stdio.h>
#include <stdlib.h>
#include <io.h>

inline int hchar(int n) { return n < 10? n + '0' : n + 'A' - 10; }

char fig[8] = {0x21, 0xf9, 0x04, 0x01, 0, 0, 1/*trnsp. clr.idx*/, 0};

int main(int argc, char *argv[]) {
    if (argc != 3 && argc != 4) { fprintf(stderr, "Usage: trnspgif <infile> <outfile> [colour index]\n  - mark a colour of gif image as transparent\n"); return 1; }
    FILE *f = fopen(argv[1], "rb"); if (!f) { perror(argv[1]); return 2; }
    FILE *g = fopen(argv[2], "wb"); if (!g) { perror(argv[2]); return 2; }
    if (argc == 4) fig[6] = atoi(argv[3]);
    unsigned char c;
    int ctszpd = 13;
    for(int n = 0;fread(&c, 1, 1, f) == 1; n++) {
        if (n == 4) {
            c = 0x39;
        } else
        if (n == ctszpd) {
            fwrite(fig, 1, 8, g);
        } else
        if (n == 10) {
            if (c & 128) ctszpd = 13 + (3 << ((c & 7) + 1));
        }
        fwrite(&c, 1, 1, g);
    }
    fclose(g); fclose(f); 
    return 0;
}
